/*
  Mobile Alphabet
  (C) Igor Markov, 2005
  This code is GPL
*/

package alfabet;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.Sprite;
import java.util.Random;


public class Letters extends Canvas implements Runnable {
    
    boolean exit = false;
    boolean paused = false;
    Image map = null;

    boolean legs=true;
    int letter = 0;
   // int newl2;
    int letters_count = 30;
    int hand;
    int leg;

    static final int AZ = 0;
    static final int ZA = 1;
    static final int RANDOM = 2;

    //static final int hands[] = {11, 15, 14};
    static final int hands[] = {11, 15, 2};

    int mode = RANDOM;
    static final int lsize = 64;
    int icols;
    Random rand = new Random();

    public void new_hand() {
	switch (letter)
        {
            case 11:
                hand=15;
                leg=15;
                break;
            case 15:
                hand=11;
                leg=11;
                break;
            case 2:
                hand=2;
                leg=2;
                break;
            default:
                hand = hands[Math.abs(rand.nextInt())%3];
                leg = hands[Math.abs(rand.nextInt())%3];
         }
        
    }

    public void generate_next() {
	//int newl;
        switch (mode) {
	    case AZ:
		letter = (letter+1)%letters_count;
		break;
	    case ZA:
		letter = (letter-1+letters_count)%letters_count;
		break;
	    case RANDOM:
		int newl2;
                newl2 = Math.abs(rand.nextInt())%letters_count;
                while (newl2 ==letter)
                 newl2  = Math.abs(rand.nextInt())%letters_count;
                letter=newl2;
                 
		break;
	}
	new_hand();
    }
    
    public Letters () {
//	setFullScreenMode(true);
	new_hand();
	loadMap();
    }

    private void loadMap() {
	if (map == null) try {
	    //map = Image.createImage("/letters/ru_abc-1.png");
              map = Image.createImage("/ru_abc-1.png");
            icols = 6;
	} catch (Exception e) {
	    icols = 1;
	}
    }

    private void drawLetter(Graphics g, int l, int x, int y, int rotate, int align) {
	//g.drawRegion(map, lsize*(l%icols), lsize*(l/icols), lsize, lsize, rotate, x, y, align);
        g.drawRegion(map, lsize*(l%icols), lsize*(l/icols), lsize, lsize, rotate, x, y, align);
    }
    
    private void drawLetters(Graphics g, int l, int h, int lg, int x, int y, int rotate) {
	if (legs)
        {
           drawLetter(g, l, x+rot_let_x[rotate], y+rot_let_y[rotate], letter_transforms[rotate], letter_alignments[rotate]);
	     drawLetter(g, h, x, y, letter_transforms[rotate], g.HCENTER|g.VCENTER);
             drawLetter(g, lg, x-rot_let_x[rotate], y-rot_let_y[rotate], letter_transforms[rotate],letter_alignments[rotate^2]);
        }
        else
        {
               drawLetter(g, l, x, y, letter_transforms[rotate], letter_alignments[rotate]);
               drawLetter(g, h, x, y, letter_transforms[rotate], letter_alignments[rotate^2]);
        }

    }

    static final int letter_alignments[] = 
    { Graphics.HCENTER|Graphics.BOTTOM, Graphics.LEFT|Graphics.VCENTER,
      Graphics.HCENTER|Graphics.TOP, Graphics.RIGHT|Graphics.VCENTER };
    static final int letter_transforms[] = 
    { Sprite.TRANS_NONE, Sprite.TRANS_ROT90,
      Sprite.TRANS_ROT180, Sprite.TRANS_ROT270 };
    static final int rot_let_x[]=
    {0,-lsize/2,0,lsize/2};
    static final int rot_let_y[]=
    {-lsize/2,0,lsize/2,0};
    
    boolean splash = true;

    public synchronized void paint(Graphics g) {
	int width = getWidth();
	int height = getHeight();

        g.setColor(0xFFFFFF);
        g.fillRect(0,0,width,height); 
	    g.setColor(0);
	    if (splash) {
		drawSplash(g, width, height);
		return;
	    }
	    if (help_screen) {
		drawHelp(g, width, height);
		return;
	    }
	    if (legs)  drawLetters(g, letter, hand,leg, width/2, height/2, rot);
              else drawLetters(g, letter, hand,leg, width/2, height/2, rot);
	    
	    if (olddelay > 0)
		g.drawString(" " + delays[delay] + " ms", 0, 0, g.TOP|g.LEFT);
    }

    private void drawSplash(Graphics g, int w, int h) {
        String title = "Новый Код";
	String appname = "Алфавит";
	String vers  = "версия 1.2";
	String help = "для справки нажмите #";
	String copy = "(c)И.Марков,А.Капустин,2008";

	
	Font bold = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE);
	Font norm = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
	int bh = bold.getHeight();
	int nh = norm.getHeight();
	int sp = (h - (4*nh + bh))/3;
	
	w /= 2;
	int v = 0;
	g.setColor(0x4040FF);
	g.setFont(norm);
	g.drawString(title, w, 0, g.TOP|g.HCENTER);
	g.setColor(0);
	g.drawString(vers, w, sp+bh+nh, g.TOP|g.HCENTER);
	g.drawString(help, w, sp*2+bh+2*nh, g.TOP|g.HCENTER);
	g.drawString(copy, w, h, g.BOTTOM|g.HCENTER);
	g.setFont(bold);
	g.drawString(appname, w, sp+nh, g.TOP|g.HCENTER);
    }

    boolean help_screen = false;

        private void drawHelp(Graphics g, int w, int h) {
	final String help[] = {"6 - медленнее", "4 - быстрее", "0 - повернуть изображение", 
	"2 - в алфавитном порядке", "8 - в обратном", "5 - в случайном","1 - буква для ног",
	"# - показать эту справку", "красная кнопка - выйти"};
	Font font = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL);
	g.setFont(font);
	int v = font.getHeight();
	for(int i=0; i<help.length; i++)
	    g.drawString(help[i], 2, 4 + v*i, g.TOP|g.LEFT);
	
    }

    
    int delays[] = {500, 600, 700, 800,900, 1000,1100, 1200, 1500,1600, 1700, 1800, 1900, 2000, 2100,2200,2300,2400,2500, 3000};
    int delay = 12;
    int olddelay;
    int rot = 0;

    public synchronized void keyPressed(int keyCode) {
	
	if (help_screen) {
	    help_screen = false;
	    repaint();
	    notifyAll();
	    return;
	}
	
	if(!splash) switch (keyCode) {
	    case KEY_NUM4:
		if (delay > 0) delay--;
		olddelay = 2300;
		repaint();
		break;
	    case KEY_NUM6:
		if (delay < delays.length - 1) delay++;
		olddelay = 2700;
		repaint();
		break;
	    case KEY_NUM0:
		rot++;
		rot %= 4;
		repaint();
		break;
	    case KEY_NUM2:
		if (mode == AZ) letter=letters_count-1;
		mode = AZ;
		break;
	    case KEY_NUM8:
		if (mode == ZA) letter = 0;
		mode = ZA;
		break;
	    case KEY_NUM5:
		mode = RANDOM;
		break;
            case KEY_NUM1:
		legs = !legs;
		break;    
	    case KEY_POUND:
		help_screen = true;
		notifyAll();
		break;
	}
    }

    public void run() {
	while(!exit) synchronized (this) {
	    try {
	        if (paused) {
		    map = null;
		    olddelay = 3000;
		    wait();
		    continue;
		}
	        if (help_screen) {
		    repaint();
		    wait();
		    continue;
		}

		if (splash) {
		    wait(900);
		    splash = false;
		    repaint();
		}
		
		wait(delays[delay]);
	        generate_next();
		repaint();
                try 
       {
	    com.nokia.mid.ui.DeviceControl.setLights(0,10);
	} 
        catch (java.lang.Error e) 
        {
	    /* Not Nokia */
	}
      

                
		if( (olddelay -= delays[delay]) < 0 ) olddelay = 0;
	    } catch (InterruptedException e) {
		/* Who's there? */		
	    }
	}
    }
}
